from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Int, Float

Openswathanalyzer_V0_1_0 = CommandToolBuilder(tool="OpenSwathAnalyzer", base_command=["OpenSwathAnalyzer"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*                    Input file containing the chromatograms. (valid formats: 'mzML')")), ToolInput(tag="in_tr", input_type=File(optional=True), prefix="-tr", doc=InputDocumentation(doc="*                    Transition file (valid formats: 'traML')")), ToolInput(tag="in_rt_norm", input_type=File(optional=True), prefix="-rt_norm", doc=InputDocumentation(doc="RT normalization file (how to map the RTs of this run to the ones stored in the library) (valid formats: 'trafoXML')")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="*                   Output file (valid formats: 'featureXML')")), ToolInput(tag="in_no_strict", input_type=Boolean(optional=True), prefix="-no-strict", doc=InputDocumentation(doc="Run in non-strict mode and allow some chromatograms to not be mapped.")), ToolInput(tag="in_swath_files", input_type=Int(optional=True), prefix="-swath_files", doc=InputDocumentation(doc="[applies only if you have full MS2 spectra maps] Swath files that were used to extract the transitions. If present, SWATH specific scoring will be used. (valid formats: 'mzML')")), ToolInput(tag="in_min_upper_edge_dist", input_type=Float(optional=True), prefix="-min_upper_edge_dist", doc=InputDocumentation(doc="[applies only if you have full MS2 spectra maps] Minimal distance to the edge to still consider a precursor, in Thomson (only in SWATH) (default: '0.0')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="*                   Output file (valid formats: 'featureXML')"))], container="quay.io/biocontainers/openms:2.6.0--h4afb90d_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Openswathanalyzer_V0_1_0().translate("wdl")

